<?php if (!defined('ABSPATH')) { exit; } // Exit if accessed directly
/**
 * Amp_WP_Add_Ons Class
 * 
 * This is used to define AMP WP Add-ons Page.
 * 
 * @link		http://pixelative.co
 * @since		1.1.0
 *
 * @package		Amp_WP_Add_Ons
 * @subpackage	Amp_WP_Add_Ons/includes
 * @author		Pixelative <mohsin@pixelative.co>
 */
class Amp_WP_Add_Ons {
    
    /**
         * Initialize the class and set its properties.
	 *
         * @since    1.1.0
	 * @param      string    $plugin_name       The name of this plugin.
	 * @param      string    $version    The version of this plugin.
         */
    public function __construct() {
		
		// Action - Add Settings Menu
        add_action( 'admin_menu', array($this, 'admin_menu'), 40 );
    }

	/**
	 * Add Add-ons Page Under AMP WP Admin Menu.
	 * 
	 * @since   1.1.0
	 */
    public function admin_menu() {
		add_submenu_page(
            'amp-wp-welcome', // string $parent_slug
            'Add-ons', // string $page_title
            'Add-ons', // string $menu_title
            'manage_options', // string $capability
            'amp-wp-add-ons', // string $menu_slug
            array( $this, 'amp_wp_add_ons' ) // callable $function
        );
    }
	
	/**
	 * Add Add-ons Page.
	 * 
	 * @Since   1.1.0
	 */
	public function amp_wp_add_ons() {
		$page = filter_input(INPUT_GET, 'page');
        require_once AMP_WP_TEMPLATE_DIR_PATH . 'admin/partials/amp-wp-admin-add-ons.php';
    }
}
new Amp_WP_Add_Ons();