<?php
// This file is not called from WordPress. We don't like that.
! defined( 'ABSPATH' ) and exit;

/**
 **********************************************************************************************************
 * 												DO NOT EDIT THIS FILE
 **********************************************************************************************************
 * Theme Options
 *
 * @author		wpthms
 * @copyright	Copyright ( c ) wpthms
 * @link		http://wpthms.com
 * @since		Version 1.0
 * @package 	Yeah Includes
 */

if( !function_exists( 'yt_theme_options' ) ) {
	
	function yt_theme_options() {
		
		$yt_data = yt_get_options();
		
		$on_off = array(
			'on' => __('ON', 'wpthms'), 
			'off' => __('OFF', 'wpthms')
		);
		$show_hide = array(
			'show' => __('Show', 'wpthms'), 
			'hide' => __('Hide', 'wpthms')
		);
		
		/* Font faces */
		$fontfaces = yt_get_option_vars( 'fontfaces' );
		// Yes/No
			
		$yes_no = array('1' => __('Yes', 'wpthms'), '0' => __('No', 'wpthms'));
		
		//
		$enable_disable = array(
			'enable' => __('Enable', 'wpthms'), 
			'disable' => __('Disable', 'wpthms')
		);
		
		// True/False
		$true_false = array(
			'true' => __('True', 'wpthms'), 
			'false' => __('False', 'wpthms')
		);		
		
		//$yt_subscription_form = array('file' => __('Save to .CSV file','wpthms'), 'mailchimp' => 'MailChimp', 'feedburner' => 'FeedBurner');
			
		//Background Images Reader
		$bg_images_path = yt_get_overwritable_directory( '/images/bg/' ); // change this to where you store your bg images
		$bg_images_url = yt_get_overwritable_directory_uri( '/images/bg/' ) ; // change this to where you store your bg images
		
		
		$bg_images = array();
		
		if ( is_dir($bg_images_path) ) {
			if ($bg_images_dir = opendir($bg_images_path) ) { 
				while ( ($bg_images_file = readdir($bg_images_dir)) !== false ) {
					if(stristr($bg_images_file, '.png') !== false || stristr($bg_images_file, '.jpg') !== false) {
						$bg_images[] = $bg_images_url . $bg_images_file;
					}
				}    
			}
		}
		
		//print_r($bg_images);
		/*-----------------------------------------------------------------------------------*/
		/* TO DO: Add options/functions that use these */
		/*-----------------------------------------------------------------------------------*/
		
		//More Options
		$uploads_arr = wp_upload_dir();
		$all_uploads_path = $uploads_arr['path'];
		$all_uploads = get_option('yt_uploads');
		$other_entries = array('Select a number:','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19');
		$body_repeat = array('no-repeat','repeat-x','repeat-y','repeat');
		$body_pos = array('top left','top center','top right','center left','center center','center right','bottom left','bottom center','bottom right');
		
		// Image Alignment radio box
		$yt_options_thumb_align = array('alignleft' => 'Left','alignright' => 'Right','aligncenter' => 'Center'); 
				
		$url =  wpthms_FRAMEWORK_URI . 'admin/assets/images/';	
		
		$yt_options = array();
		
		$layout = apply_filters( 'yt_theme_options_option_general_site_layout' ,array(
			'default' => 'default',
			'left-sidebar' => '4+8',
			'fullwidth' => '12',
			'right-sidebar' => '8+4',
		) );
		/**
		 * General Settings
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_generalsettings', array(	
			array( 
				'name' => __('General Settings','wpthms'),
				'desc' => __('Logo, Email, Copyright ,Contact/Branding informations ...','wpthms'),
				'type' => 'heading',
				'customize' => 1,
				'settings' => array(
					'icon' => 'generalsettings'
				)
				
			),
			array( 
				'name' => __('Plain Text Logo','wpthms'),
				'desc' => sprintf(__('You can change site title and site tagline in <a href="%s">%s</a>','wpthms'), admin_url( 'options-general.php' ), __('Settings -> General', 'wpthms' ) ),
				'id' => 'plain_logo',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable a plain text logo rather than an image.','wpthms'),
				)
			),
			array( 
				'name' => __('Custom Logo','wpthms'),
				'desc' => __('Upload a logo for your theme, or specify the image address of your online logo. (http://example.com/logo.png) <br>Dimension: 250px for width and 100px for height (if you use short banner it will be 80px).','wpthms'),
				'id' => 'logo',
				'std' => wpthms_URI . 'images/logo.png',
				'type' => 'media',
				'customize' => 1,
				'settings' => array(
					'sanitize' => 'esc_url',
				)
			),
		) ) ); 
			
		/**
		 * Post types Setting
		 */
		// $yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_posttypesettings', array(	
		// 	array( 
		// 		'name' => __('Post type settings','wpthms'),
		// 		'type' => 'heading',
		// 		'customize' => 1,
		// 		'settings' => array(
		// 			'icon' => 'posttypesettings'
		// 		)
		// 	),
		// ) ) );
		
		
		$url =  wpthms_FRAMEWORK_URI . 'admin/assets/images/';	
		/**
		 * Interface Settings
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_interfacesettings', array(	
			
			array( 
				'name' => __('Interface Settings','wpthms'),
				'type' => 'heading',
				'desc' => __('Configure appearance of elements on the the site (eg: disable Responsiveness or change footer layout)','wpthms'),
				'customize' => 1,
				'settings' => array(
					'icon' => 'interfacesettings'
				)
			),
		) ) );

		/**
		 * Interface Settings - overall
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_interfacesettings_overall', array(
			array( 
				'type' => 'subheading',
				'name' => __('Overall','wpthms'),
				'customize' => 1,
				'customize_name' => __('Interface Settings - Overall','wpthms'),
			),
			array( 
				'name' => __('Boxed layout','wpthms'),
				'desc' => '',
				'id' => 'site_boxed_layout_mode',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'settings' => array(
					'label' => __('Toggle this to enable boxed layout (narrow width).','wpthms'),
				)
			),
			array( 
				'name' => __('Large display layout','wpthms'),
				'desc' => __('1200px and up','wpthms'),
				'id' => 'site_width_large_mode',
				'std' => 0,
				'type' => 'checkbox',	
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable wide layout for large display.', 'wpthms'),
				)
			),
			array(
				'name' 		=> __( 'Site Max width', 'wpthms' ),
				'desc'		=> __( 'Set the width of inner container', 'wpthms' ),
				'id' 		=> 'site_width',
				'std' 		=> 'default',
				'type' 		=> 'select',
				'options' 	=> array(
					1370 			=> __( 'Default (1370px)', 'wpthms' ),
					1200 			=> __( '1200px', 'wpthms' ),
					1140 			=> __( '1140px', 'wpthms' ),
				),
				'settings'	=> array(
					
					'fold' => 'site_width_large_mode',
				)
			),
			array( 
				'name' => __('Default Content/sidebar Layout','wpthms'),
				'desc' => __('Select main content and sidebar alignment.','wpthms'),
				'id' => 'layout',
				'std' => 'default',
				'type' => 'columns',
				'options' => $layout
				
			),
			array( 
				'name' => __('Page comment box','wpthms'),
				'desc' => '',
				'id' => 'site_page_comment_mode',
				'std' => 0,
				'type' => 'checkbox',	
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'settings' => array(
					'label' => __('Toggle this to enable Page comment box.', 'wpthms'),
				)
			),
			array(
				'type' => 'separator',
				'name' => __('Sidebars on Small screens','wpthms'),
			),
			array(
				'name' => __('Main sidebar','wpthms'),
				'desc' => __('Show/hide sidebar on Small screen sizes.','wpthms'),
				'id' => 'site_page_main_sidebar',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,

				'customize' => 1,
			),
			array(
				'name' => __('Sub sidebar','wpthms'),
				'desc' => __('Show/hide sidebar on Small screen sizes.','wpthms'),
				'id' => 'site_page_sub_sidebar',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,

				'customize' => 1,
			),
		) ) );
		/**
		 * Interface Settings - overall
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_interfacesettings_herobanner', array(
			array( 
				'type' => 'subheading',
				'name' => __( 'Hero Banner', 'wpthms'),
				'customize' => 1,
				'customize_name' => __('Interface Settings - Hero Banner','wpthms'),
			),

			array(
				'name' => '',
				'type' => 'info',
				'std' => '<h3>Default: Showing latest posts</h3>'
			),
			array( 
				'name' 		=> __( 'Hero Banner', 'wpthms' ),
				'desc'		=> __( 'Turn on/off hero banner', 'wpthms' ),
				'id' 		=> 'herobanner_mode',
				'std' 		=> 1,
				'type' 		=> 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'settings' => array(
					'folds' 	=> '0',
					'label' 	=> __( 'Enable/Disable', 'wpthms' ),
				)
			),
			array( 
				'name' 		=> __( 'Hero Banner layout', 'wpthms' ),
				'desc' 		=> __( 'Choose your Hero banner layout you wish to use on this page', 'wpthms' ),
				'id' 		=> 'herobanner_layout',
				'std' 		=> 'default',
				'type' 		=> 'images',
				'options' 	=> array(
					'default' 			=> wpthms_INCLUDES_URI . 'images/brick_default.png',
					'two_one_two' 			=> wpthms_INCLUDES_URI . 'images/brick_212.png',
					'symmetry_brick' 	=> wpthms_INCLUDES_URI . 'images/brick_1221.png',
					'triple' 			=> wpthms_INCLUDES_URI . 'images/brick_triple.png',
					'two_three' 		=> wpthms_INCLUDES_URI . 'images/brick_2x3.png',
					'carousel' 			=> wpthms_INCLUDES_URI . 'images/brick_carousel.png',
					
				),
				'settings' =>  array(
					'width' 	=> '120px', 
					'height' 	=> '60px'
				)
				
			),

			array(
				'name' 		=> __( 'Shuffle posts', 'wpthms' ),
				'desc'		=> '',
				'id' 		=> 'herobanner_shuffleposts',
				'std' 		=> 0,
				'type' 		=> 'checkbox',
				'class' 	=> 'yt-inline-input',
				'settings' => array(
					'is_indexed' => 1,
					'label' 	=> __( 'Show post bricks shufflingly', 'wpthms' ),
				)
			),
			array(
				'name' 		=> __( 'Brick Gap size', 'wpthms' ),
				'desc'		=> '',
				'id' 		=> 'herobanner_gap',
				'std' 		=> 'default',
				'type' 		=> 'select',
				'options' 	=> array(
					'default' 		=> __( 'Default (large)', 'wpthms' ),
					'medium' 		=> __( 'Medium', 'wpthms' ),
					'small' 		=> __( 'Small', 'wpthms' ),
					'none' 			=> __( 'No Gap', 'wpthms' ),
				)
			),
			array(
				'name' 		=> __( 'Brick content alignment', 'wpthms' ),
				'desc'		=> '',
				'id' 		=> 'herobanner_brickalign',
				'std' 		=> 'default',
				'type' 		=> 'select',
				'options' 	=> array(
					'default' 		=> __( 'Default (large)', 'wpthms' ),
					'center' 		=> __( 'Center', 'wpthms' ),
					'left' 		=> __( 'Right', 'wpthms' ),
				)
			),
			array(
				'name' 		=> __( 'Hero Banner style', 'wpthms' ),
				'desc'		=> __( 'Choose your Hero banner layout. For Overlay color by Category, you need to specific accent color for category in editing category page.', 'wpthms' ),
				'id' 		=> 'herobanner_style',
				'std' 		=> 'date',
				'type' 		=> 'select',
				'options' 	=> array(
					'default' 		=> __( 'Default (Dark gradient)', 'wpthms' ),
					'color' => __( 'Overlay color by Category', 'wpthms' ),
					'mixed' 		=> __( 'Mixed Gradient (It\'s nice :) ) ', 'wpthms' ),
				),
				'settings' => array(
					'folds' => '1',
				)
			),
			array( 
				'name' 		=> __( 'Random color', 'wpthms' ),
				'desc'		=> '',
				'id' 		=> 'herobanner_style_random',
				'std' 		=> 0,
				'type' 		=> 'checkbox',
				'settings' => array(
					'fold' => 'herobanner_style',
					'fold_value' => 'mixed',
					'label' 	=> __( 'Check this to use randomized overlay effect', 'wpthms' ),
				)
			),
			array(
				'name' 		=> __( 'Animation type', 'wpthms' ),
				'desc'		=> __( 'Choose your Hero banner Appearance Effect', 'wpthms' ),
				'id' 		=> 'herobanner_effect',
				'std' 		=> 'zoomIn',
				'type' 		=> 'select',
				'options' 	=> array(
					'none'			=> __('No Effect', 'wpthms'),
					'bounceIn'		=> __('Bounce in', 'wpthms'),
					'bounceInDown'	=> __('Bounce in down', 'wpthms'),
					'bounceInUp'	=> __('Bounce in up', 'wpthms'),
					'bounceInLeft'	=> __('Bounce in left', 'wpthms'),
					'bounceInRight'	=> __('Bounce in right', 'wpthms'),
					'fadeIn'		=> __('Fade in', 'wpthms'),
					'fadeInUp'		=> __('Fade in up', 'wpthms'),
					'fadeInDown'	=> __('Fade in down', 'wpthms'),
					'fadeInLeft'	=> __('Fade in left', 'wpthms'),
					'fadeInRight'	=> __('Fade in right', 'wpthms'),
					'fadeInZoom'	=> __('Fade in zoom', 'wpthms'),
					'flipIn'		=> __('Flip in', 'wpthms'),
					'flipInX'		=> __('Flip in horizontal', 'wpthms'),
					'flipInY'		=> __('Flip in vertical', 'wpthms'),
					'lightSpeedIn'	=> __('Light speed', 'wpthms'),
					'pageTop'		=> __('Page top', 'wpthms'),
					'pageBottom'	=> __('Page bottom', 'wpthms'),
					'pageLeft'		=> __('Page left', 'wpthms'),
					'pageRight'		=> __('Page right', 'wpthms'),
					'rollIn'		=> __('Roll in', 'wpthms'),
					'rotateIn'		=> __('Rotate In', 'wpthms'),
					'rotateInDownLeft'	=> __('Rotate in down left', 'wpthms'),
					'rotateInDownRight'	=> __('Rotate in down right', 'wpthms'),
					'rotateInUpLeft'	=> __('Rotate in up left', 'wpthms'),
					'rotateInUpRight'	=> __('Rotate in up left', 'wpthms'),
					'slideInDown'	=> __('Slide in down', 'wpthms'),
					'slideInLeft'	=> __('Slide in left', 'wpthms'),
					'slideInRight'	=> __('Slide in right', 'wpthms'),
					'zoomIn'		=> __('Zoom in', 'wpthms'),
					'zoomOut'		=> __('Zoom out', 'wpthms')
				)
			),
			array(
				'name' => __('Categories (Optional)','wpthms'),
				'id' => 'herobanner_cat',
				'type' => 'tag_search',
				'std' => '',
				'desc' => __('Specific categories you wish to retrieve posts from. Keep typing and you will be suggested','wpthms'),
				'settings' => array(
					'tax' => 'category'
				)
			),
			array(
				'name' 		=> __( 'Tagged In (Optional)', 'wpthms' ),
				'desc'		=> __( 'Specify tags you wish to retrieve posts from. Keep typing and choose suggested tags from the dropdown', 'wpthms' ),
				'id' 		=> 'herobanner_tagin',
				'std' 		=> '',
				'type' 		=> 'tag_search',
				//'options' 	=> yt_get_tag_list()
			),
			array(
				'name' => __('Exclude Categories (Optional)','wpthms'),
				'id' => 'herobanner_catnotin',
				'type' => 'tag_search',
				'std' => '',
				'desc' => __('Keep typing and you will be suggested','wpthms'),
				'settings' => array(
					'tax' => 'category'
				)
			),
			array(
				'name' => __('Exclude Tags (Optional)','wpthms'),
				'id' => 'herobanner_tagnotin',				
				'type' => 'tag_search',
				'std' => '',
				'desc' => __('Keep typing and you will be suggested','wpthms'),
			),
			array(
				'name' 		=> __( 'Order', 'wpthms' ),
				'desc'		=> '',
				'id' 		=> 'herobanner_order',
				'std' 		=> 'DESC',
				'type' 		=> 'select',
				'options' 	=> array(
					'DESC' 		=> __( 'Descending', 'wpthms' ),
					'ASC' 		=> __( 'Ascending', 'wpthms' ),
				)
			),
			array(
				'name' 		=> __( 'Order by', 'wpthms' ),
				'desc'		=> '',
				'id' 		=> 'herobanner_orderby',
				'std' 		=> 'date',
				'type' 		=> 'select',
				'options' 	=> array(
					'date' 		=> __( 'Date', 'wpthms' ),
					'title' 	=> __( 'Title', 'wpthms' ),
					'name' 		=> __( 'Post slug', 'wpthms' ),
					'author' 	=> __( 'Author', 'wpthms' ),
					'modified' => __( 'Last modified date', 'wpthms' ),
					'comment_count' => __( 'Number of comments', 'wpthms' ),
					'rand' 		=> __( 'Random order', 'wpthms' ),
					// 'meta_value_num' => __( 'Post Views', 'wpthms' ),
				)
			),
			array(
				'name' 		=> __( 'Number of posts', 'wpthms' ),
				'desc'		=> sprintf(__( 'Default: %s. (this option only apply to carousel layout)', 'wpthms' ), 8 ),
				'id' 		=> 'herobanner_postsperpage',
				'std' 		=> '8',
				'type' 		=> 'number',
				'class' => 'yt-section-text-number',
				'settings' 	=> array(
					'attr'	=> ' style="' . esc_attr( 'width:60px;' ) . '"',
					
				)
			),
			array(
				'name' 		=> __( 'Exclude post format', 'wpthms' ),
				'desc'		=> __( 'Specify post formats you don\'t want to retrieve.', 'wpthms' ),
				'id' 		=> 'herobanner_excludeformat',
				'std' 		=> '',
				'type' 		=> 'multicheck',
				'class' 	=> 'yt-inline-input',
				'options' 	=> yt_get_supported_post_formats(),
				'settings' => array(
					'is_indexed' => 1
				)
			),

			array(
				'name' 		=> __( 'Exclude hero posts from blog', 'wpthms' ) ,
				'desc'		=> '',
				'id' 		=> 'herobanner_excludeme_from_mainquery',
				'std' 		=> 0,
				'type' 		=> 'checkbox',
				'settings' 	=> array(
					'label' => __( 'Exclude hero posts from Main blog loop', 'wpthms' ),
				)
			)

		) ) );
		
		/**
		 * Interface Settings - Header
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_interfacesettings_header', array(	
			array(
				'name' => __('Header','wpthms'),
				'type' => 'subheading',
				'customize' => 1,
				'customize_name' => __('Interface Settings - Header','wpthms')
			),array(
				'name' => __('Top bar menu','wpthms'),
				'desc' => '',
				'id' => 'header_top_bar_menu',
				'std' => 'hide',
				'type' => 'toggles',
				'options' => $show_hide
			),array( 
				'name' => __('Scrollfix Main menu','wpthms'),
				'desc' => '',
				'id' => 'header_scrollfix_mainmenu',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'settings' => array(
					'label' => __('Toggle this to enable Scrollfix Main menu style.','wpthms'),
				)
			),array(
				'name' => __('News Mega Request type','wpthms'),
				'desc' => __('Choose the method of retrieving posts when hover to News mega menu<br>-Ajax request: Used Ajax technique to load posts when hover<br>-Regular request: loads posts instantly when hover. (this might affect to loading speed if you have many loop on a page, we recommend you to use cache plugin to reduce server response time)','wpthms'),
				'id' => 'main_megamenu_request_type',
				'std' => 'regular',
				'type' => 'select',
				'customize' => 1,
				'options' => array(
					'ajax' => __('Ajax request', 'wpthms'),
					'regular' => __('Regular request', 'wpthms'),
				)
			),array(
				'name' => __('Social links Position','wpthms'),
				'desc' => '',
				'id' => 'header_social_links_position',
				'std' => 'hide',
				'type' => 'select',
				'customize' => 1,
				'options' => array(
					'hide' => __('Hide', 'wpthms'),
					'top_menu' => __('Top Menu bar', 'wpthms'),
					'main_menu' => __('Main Menu bar', 'wpthms'),
				)
			),
			array(
				'name' => __('Site Search box type','wpthms'),
				'desc' => '',
				'id' => 'site_search_type',
				'std' => 'modal',
				'type' => 'select',
				'customize' => 1,
				'options' => array(
					'default' => __('Defaul (dropdown)', 'wpthms'),
					'modal' => __('Open in Modal box', 'wpthms'),
				),
				'settings' => array(
					'folds' => '0',
				)
			),
			array( 
				'name' => __('Modal search box type', 'wpthms'),
				'desc' => '',
				'id' => 'site_modal_search_request_type',
				'std' => 'regular',
				'type' => 'select',
				'settings' => array(
					'fold' => 'site_search_type',
					'fold_value' => 'modal',
				),
				'options' => array(
					'ajax' => __('Ajax request', 'wpthms'),
					'regular' => __('Regular request', 'wpthms'),
				)	
			),
			array( 
				'name' => __('Site News Ticker','wpthms'),
				'desc' => '',
				'id' => 'site_news_tickers_mode',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable News Tickes (aka. Breaking News in Demo)','wpthms'),
				)
			),
			array( 
				'name' => __('Site News Ticker Title','wpthms'),
				'desc' => '',
				'id' => 'site_news_tickers_title',
				'std' => 'Breaking News',
				'type' => 'text',
				'customize' => 1,
				'settings' => array(
					'fold' => 'site_news_tickers_mode',
				)
			),
			array(
				'name' => __('Site News Ticker Query','wpthms'),
				'desc' => '',
				'id' => 'site_news_tickers_query_posts',
				'std' => '',
				'type' => 'group_options',
				'customize' => 0,
				'options' => array(
					array(
						'name' => __('Categories','wpthms'),
						'id' => 'cat',
						'type' => 'tag_search',
						'std' => '',
						'desc' => __('Keep typing and you will be suggested','wpthms'),
						'settings' => array(
							'tax' => 'category'
						)
					),
					array(
						'name' => __('Tags','wpthms'),
						'id' => 'tag',				
						'type' => 'tag_search',
						'std' => '',
						'desc' => __('Keep typing and you will be suggested','wpthms'),
					),
					array(
						'name' => __('Order','wpthms'),
						'id' => 'order',						
						'type' => 'select',
						'std' => 'DESC',
						'desc' => __('Keep typing and you will be suggested','wpthms'),
						'options' => array(
							'DESC' 		=> __( 'Descending', 'wpthms' ),
							'ASC' 		=> __( 'Ascending', 'wpthms' ),
						)
					),
					array(
						'name' => __('Order by','wpthms'),
						'id' => 'orderby',
						'std' => 'DESC',
						'type' => 'select',
						'options' => array(
							'date' 		=> __( 'Date', 'wpthms' ),
							'title' 	=> __( 'Title', 'wpthms' ),
							'name' 		=> __( 'Post slug', 'wpthms' ),
							'author' 	=> __( 'Author', 'wpthms' ),
							'modified' => __( 'Last modified date', 'wpthms' ),
							'comment_count' => __( 'Number of comments', 'wpthms' ),
							'rand' 		=> __( 'Random order', 'wpthms' ),
							'meta_value_num' => __( 'Post Views', 'wpthms' ),
						)
					),
					array(
						'name' => __('Number of Posts','wpthms'),
						'id' => 'posts_per_page',						
						'type' => 'number',
						'std' => 10
					),
					array(
						'name' => __('Exclude post format','wpthms'),
						'id' => 'excludeformat',						
						'type' => 'multicheck',
						'std' => array(),
						'options' => yt_get_supported_post_formats(),
						'settings' => array(
							'is_indexed' => 1
						)
					),

				),
				'settings' => array(
					'fold' => 'site_news_tickers_mode',
				)
			)

		) ) ); 

		/**
		 * Interface Settings - footer
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_interfacesettings_footer', array(	
			array( 
				'type' => 'subheading',
				'name' => __('Footer','wpthms'),
				'customize' => 1,
				'customize_name' => __('Interface Settings - Footer','wpthms'),
			),
			array( 
				'name' => __('Footer Layout','wpthms'),
				'desc' => __('Select a footer layout style. (full, half, small)','wpthms'),
				'id' => 'footer_layout',
				'std' => 'footer-extra',
				'type' => 'columns',
				'options' => array(
					'footer-full-layout' => '9+3',
					'footer-widget' => '9',
					'footer-extra' => '3'
				),
				'customize' => 1,
				'settings' =>  array(
					 'direction' => 'horizontal'
				),
				
			),
			array( 
				'name' => __('Footer Columns','wpthms'),
				'desc' => __('Select the number of columns you would like to display in the footer.','wpthms'),
				'id' => 'footer_columns',
				'std' => 'col-sm-3_col-sm-3_col-sm-3_col-sm-3',
				'type' => 'columns',
				'options' => yt_get_option_vars( 'footer_columns' ),
				'customize' => 1,
				'settings' =>  array(),
			),
			array( 
				'name' => __('Left Footer credit','wpthms'),
				'id' => 'footer_text_left',
				'std' => '&copy; ' . date("Y") . ' <a href="http://' . 'wpthms.com" title="Everything you need to create a trendy, uniquely beautiful website without any of coding knowledge">wpthms</a>. All Rights Reserved. Powered by <a href="http://wordpress.org">WordPress</a>.',
				'type' => 'textarea',
				'customize' => 1,
			),
			array( 
				'name' => __('Right Footer credit','wpthms'),
				'id' => 'footer_text_right',
				'std' => '<a href="#masthead" class="back-to-top">Back to top</a>',
				'type' => 'textarea',
				'customize' => 1,
			)
		) ) );
				 
		/**
		 * Blog Settings
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_blogsettings', array(
			array( 
				'name' => __('Blog Settings','wpthms'),
				'type' => 'heading',
				'desc' => __('Configure parameters for default blog page','wpthms'),
				'customize' => 1,
				'settings' => array(
					'icon' => 'blogsettings'
				)
			),
		) ) );

		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_blogsettings_general', array(
			array(
				'type' => 'subheading',
				'name' => __('General','wpthms'),
				'customize' => 1,
				'customize_name' => __('Blog Settings - General','wpthms'),
			),
			array( 
				'name' => __('Blog Content/sidebar Layout','wpthms'),
				'desc' => __('Select main content and sidebar alignment.','wpthms'),
				'id' => 'blog_layout',
				'std' => 'default',
				'type' => 'columns',
				'options' => $layout
			),
			array( 
				'name' => __('Blog Post Layout','wpthms'),
				'desc' => '',
				'id' => 'blog_post_layout',
				'std' => 'default',
				'type' => 'select',
				'options' => array(
					'default' => __('Default','wpthms'),
					'classic' => __('Classic','wpthms'),
				)
			),
			array(
				'name' => __('Exclude Categories from Default Blog page (Page for posts)','wpthms'),
				'desc' => __('Check the categories that you don\'t want to display in main blog page (page for posts)','wpthms'),
				'id' => 'mainblog_exclude_cats',
				'std' => array(),
				'type' => 'category_checklist',
			),
			array(
				'name' => __('Excerpt output','wpthms'),
				'desc' => __('Handle output of excerpt content:<br>-Manual: Use <--more--> tag to split a first part of post content and use it as summary on main archive page.<br>-Automatic: Split your content automatically.','wpthms'),
				'id' => 'excerpt_output',
				'std' => 'manual',
				'type' => 'select',
				'options' => array(
					'manual' => __('Manual','wpthms'),
					'automatic' => __('Automatic','wpthms'),
				),
			),
			array(
				'name' => __('Excerpt length','wpthms'),
				'desc' => __('Change excerpt length to display in blog page. (default is 55 words), only apply when you handle excerpt manually.','wpthms'),
				'id' => 'custom_excerpt_length',
				'std' => 55,
				'type' => 'uislider',
				'settings' => array(
					'min' => 10,
					'max' => 300,
					'step' => 5,
					'unit' => 'w',
				)
			),
			array(
				'name' => __('Pagination','wpthms'),
				'desc' => __('Select the Pagination type for blog archive page','wpthms'),
				'id' => 'blog_pagination',
				'std' => 'number',
				'type' => 'select',
				'customize' => 1,
				'options' => array(
					'number' => __('Numeric Pagination','wpthms'), 
					'direction' => __('Next/Prev links','wpthms')
				)	
				
			),
			array(
				'name' => __('Read more button','wpthms'),
				'desc' => __('Toggle to show/hide readmore button in blog page ','wpthms'),
				'id' => 'blog_readmore_button',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,

				'customize' => 1,
			),
			array(
				'name' => __('Post format icon','wpthms'),
				'desc' => __('The icon before Post meta info','wpthms'),
				'id' => 'blog_post_format_icon',
				'std' => 'show',
				'type' => 'toggles',
				'options' => array(
					'show' => __('Show', 'wpthms'), 
					'hide' => __('Hide', 'wpthms')
				),
				'customize' => 1,
			),
			array(
				'name' => __('Review info.','wpthms'),
				'desc' => __('Review info under the entries on main loops','wpthms'),
				'id' => 'blog_post_review_info',
				'std' => 'show',
				'type' => 'toggles',
				'options' => array(
					'show' => __('Show', 'wpthms'), 
					'hide' => __('Hide', 'wpthms')
				),
				'customize' => 1,
			),
			array( 
				'name' => __('Post Meta Info','wpthms'),
				'desc' => '',
				'id' => 'blog_post_meta_info_mode',
				'std' => 'small',
				'type' => 'select',
				'class' => 'yt-section-toggle-checkbox',
				'customize' => 1,
				'options' => array(
					'hide' => __('Hide', 'wpthms'),
					'small' => __('Style 1', 'wpthms'),
					'large' => __('Style 2', 'wpthms'),
				),
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable post meta info.','wpthms'),
				)
			),
			array(
				'name' => __('Hide Post meta info','wpthms'),
				'desc' => __('Uncheck to hide the meta info in blog page','wpthms'),
				'id' => 'blog_post_meta_info',
				'std' => array(
					'author',
					'category',
					'share_button',
					'date',
					'comments',
					'likes',
					'views',
					'sizer',
				),
				'type' => 'multicheck',
				'options' => array(
					'author' => __('Author of the Post','wpthms'),
					'category' => __('Post Category','wpthms'),
					'share_buttons' => __('Sharing buttons','wpthms'),
					'date' => __('Date of Post ','wpthms'),
					'comments' => __('Comments','wpthms'),
					'likes' => __('Likes','wpthms'),
					'views' => __('Post views','wpthms'),
					'sizer' => __('Font sizer','wpthms'),
				),
				'settings' => array(
					'fold' => 'blog_post_meta_info_mode',
					'fold_value' => 'small,large',
				)
				
			)
			
			
		) ) );
		
		/**
		 * Blog Settings - Single
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_blogsettings_single', array(
			array(
				'type' => 'subheading',
				'name' => __('Single post','wpthms'),
				'customize' => 1,
				'customize_name' => __('Blog Settings - Single post','wpthms'),
			),

			array( 
				'name' => __('Single Content/sidebar Layout','wpthms'),
				'desc' => __('Select main content and sidebar alignment.','wpthms'),
				'id' => 'single_layout',
				'std' => 'default',
				'type' => 'columns',
				'options' => $layout
				
			),
			array(
				'name' => __('Featured image (Post thumnbnail)','wpthms'),
				'desc' => '',
				'id' => 'blog_single_post_featured_image',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,
				'customize' => 1,
			),
			array(
				'name' => __('Author Meta info.','wpthms'),
				'desc' => '',
				'id' => 'blog_single_post_author_meta',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,
				'customize' => 1,
			),
			array(
				'name' => __('Comment box','wpthms'),
				'desc' => '',
				'id' => 'blog_single_post_comment_template',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,
				'customize' => 1,
			),
			array(
				'name' => __('Related articles','wpthms'),
				'desc' => '',
				'id' => 'blog_single_post_related_articles',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,
				'customize' => 1,
			),array(
				'name' => __('You might also like section','wpthms'),
				'desc' => '',
				'id' => 'blog_single_post_youmightalsolike',
				'std' => 'show',
				'type' => 'toggles',
				'options' => $show_hide,
				'customize' => 1,
			)
		) ) );
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_blogsettings_archive', array(
			array(
				'type' => 'subheading',
				'name' => __('Archive','wpthms'),
				'customize' => 1,
				'customize_name' => __('Blog Settings - Archive','wpthms'),
			),
			array( 
				'name' => __('Archive Content/sidebar Layout','wpthms'),
				'desc' => __('Select main content and sidebar alignment.','wpthms'),
				'id' => 'archive_layout',
				'std' => 'default',
				'type' => 'columns',
				'options' => $layout
			),
			array( 
				'name' => __('Archive Post Layout','wpthms'),
				'desc' => '',
				'id' => 'archive_post_layout',
				'std' => 'default',
				'type' => 'select',
				'options' => array(
					'default' => __('Default','wpthms'),
					'classic' => __('Classic','wpthms'),
				)
			),
		) ) );
			
		/**
		 * Typography
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography', array(
		
			array( 
				'name' => __('Typography','wpthms'),			
				'type' => 'heading',
				'settings' => array(
					'icon' => 'typography'
				)
			)
		) ) );
			
		/**
		 * Typography - Elements
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography_elements', array(
			
			array( 
				'name' => __('Elements','wpthms'),
				'type' => 'subheading',
				'desc' => __('Configure font parameters for element','wpthms'),
			),
			array(
				'name' => '',
				'type' => 'info',
				'std' => '<h3>Change your typography style in Content Area </h3><p>(From left to right:) Font Family, Font size, Font weight, Font style, Line height, Letter Spacing, Margin Bottom</p>'
			),
			array(
				'name' => __('H1 Headings','wpthms'),
				'desc' => __('default : Helvetica 30px normal normal 1.35 0px none 35px','wpthms'),
				'id' => 'typo_h1',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '30px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.35',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '35px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('H2 Headings','wpthms'),
				'desc' => __('default : 26px normal normal 1.35 0px none 30px','wpthms'),
				'id' => 'typo_h2',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '26px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.35',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '30px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('H3 Headings','wpthms'),
				'desc' => __('default : 22px normal normal 1.75 0px none 20px','wpthms'),
				'id' => 'typo_h3',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '22px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '20px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('H4 Headings','wpthms'),
				'desc' => __('default : 20px normal normal 1.75 0px none 20px','wpthms'),
				'id' => 'typo_h4',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '20px',
					'weight' 			=> 'normal',
					'style'				=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '20px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('H5 Headings','wpthms'),
				'desc' => __('default : 16px normal normal 1.75 0px none 15px','wpthms'),
				'id' => 'typo_h5',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '16px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '15px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('H6 Headings','wpthms'),
				'desc' => __('default : 13px normal normal 1.75 0px none 10px','wpthms'),
				'id' => 'typo_h6',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '13px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '10px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Bold tag inside Headings','wpthms'),
				'desc' => __('The <strong>strong</strong> and <strong>b</strong> tag inside of Heading tags','wpthms'),
				'id' => 'typo_bold_heading',
				'std' => array(
					'face' 		=> '',
					'weight' 	=> 'bold',
					'style' 	=> 'normal',
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Body Font','wpthms'),
				'desc' => __('Specify the body font properties Default: 13px normal normal 1.75 0px none','wpthms'),
				'id' => 'typo_body_font',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '13px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					//'color' 			=> ''
				),
				'type' => 'typography'
			)
		) ) );
		/**
		 * Typography - Elements - Header
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography_elements_header', array(
			array(
				'type' => 'separator',
				'name' => __('Header','wpthms'),
			),
			array(
				'name' => __('Main Menu','wpthms'),
				'desc' => __('default : 14px normal normal','wpthms'),
				'id' => 'typo_top_menu',
				'std' => array(
					'face' 			=> '',
					'size' 			=> '14px',
					'weight' 		=> 'normal',
					'style' 		=> 'normal',
					'transform' 	=> 'none',
					'letterspacing' 	=> '0px'
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Main Menu Child Level','wpthms'),
				'desc' => __('default : 12px normal normal','wpthms'),
				'id' => 'typo_top_menu_child',
				'std' => array(
					'face' 			=> '',
					'size' 			=> '12px',
					'weight' 		=> 'normal',
					'style' 		=> 'normal',
					'transform' 	=> 'none',
					'letterspacing' 	=> '0px'
				),
				'type' => 'typography'
			),
		) ) );
		
		/**
		 * Typography - Elements - Content
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography_elements_content', array(
			array(
				'type' => 'separator',
				'name' => __('Content','wpthms'),
			),
			array(
				'name' => __('Home Brick Entry title','wpthms'),
				'desc' => __('default : 40px normal normal 50px 0px none 0px','wpthms'),
				'id' => 'typo_home_brick_entry_title',
				'std' => array(
					'face' 				=> '',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.25',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Entry title','wpthms'),
				'desc' => __('default : 36px normal normal 1.35 0px none','wpthms'),
				'id' => 'typo_entry_title',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '36px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.35',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					//'marginbottom' 	=> '0px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Single Page/Post title','wpthms'),
				'desc' => __('default : 40px normal normal 1.35 0px none','wpthms'),
				'id' => 'typo_page_title',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '40px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.35',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					//'marginbottom' 	=> '30px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Sidebar widget\'s Headings','wpthms'),
				'desc' => __('default : 18px normal normal 1.75 0px none','wpthms'),
				'id' => 'typo_sidebar_widget_headings',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '18px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '15px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
		) ) );
		/**
		 * Typography - Elements - Footer
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography_elements_footer', array(
			array(
				'type' => 'separator',
				'name' =>  __('Footer','wpthms'),
			),
			array(
				'name' => __('Footer Headings','wpthms'),
				'desc' => __('default : 18px normal normal 1.75 0px none','wpthms'),
				'id' => 'typo_footer_headings',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '18px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					'marginbottom' 	=> '15px',
					//'color' 			=> ''
				),
				'type' => 'typography'
			),
			array(
				'name' => __('Footer Elements','wpthms'),
				'desc' => __('Specify the footer element font properties Default: 13px normal normal 1.75 0px none','wpthms'),
				'id' => 'typo_footer_element',
				'std' => array(
					'face' 				=> '',
					'size' 				=> '13px',
					'weight' 			=> 'normal',
					'style' 			=> 'normal',
					'height' 			=> '1.75',
					'letterspacing' 	=> '0px',
					'transform' 		=> 'none',
					//'color' 			=> ''
				),
				'type' => 'typography'
			)
		) ) );
		/**
		 * Typography - Google Font
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography_googlefont', array(
		
			array( 
				'name' => __('Google Font','wpthms'),
				'type' => 'subheading',
				'desc' => __('Add, Remove font from <a href="http://www.google.com/webfonts/" target="_blank">Google Web Fonts</a> Library','wpthms'),
			),
			array( 
				'name' => '',
				'desc' => '',
				'std' => __('<p>Checkout <a href="http://www.google.com/webfonts/" target="_blank">Google Web Fonts</a> Library. for a complete list of available font.</p>','wpthms'),
				'type' => 'info'
			),
			array( 
				'name' => __('Enable Google font','wpthms'),
				'desc' => __('Click <strong>Enable</strong> to use Google webfont from <strong>Font Family</strong> select box','wpthms'),
				'id' => 'googlefont_mode',
				'std' => 'disable',
				'type' => 'toggles',
				'options' => $enable_disable
			),
			array( 
				'name' => __('Character sets','wpthms'),
				'desc' => __('If you choose only the languages that you need, you\'ll help prevent slowness on your webpage.<br><br>Notice: The theme will load font subsets if available!','wpthms'),
				'id' => 'googlefont_subsets',
				'type' => 'multicheck',
				'std' => array(),
				'options' => array(
					'latin' => __('Latin','wpthms'),
					'latin-ext' => __('Latin Extended','wpthms'),
					'cyrillic' => __('Cyrillic','wpthms'),
					'cyrillic-ext' => __('Cyrillic Extended','wpthms'),
					'greek' => __('Greek','wpthms'),
					'greek-ext' => __('Greek Extended','wpthms'),
					'khmer' => __('Khmer','wpthms'),
					'vietnamese' => __('Vietnamese','wpthms'),
				)
				
			)
		) ) );
		/**
		 * Typography - Custom Font
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_typography_customfont', array(
				
			array( 
				'name' => __('Custom Font','wpthms'),
				'type' => 'subheading',
				'desc' => __('Upload Custom font from your Computer','wpthms')
			),
			array( 
				'name' => '',
				'desc' => '',
				'std' => '<h3>Upload your custom font</h3><p>Remember to Refesh this page after hitting Save Changes so the Font family list will update the new fonts</p>',
				'type' => 'info'
			),
			array( 
				'name' => __('Enable Custom font','wpthms'),
				'desc' => __('Click <strong>Enable</strong> to use Google webfont from <strong>Font Family</strong> select box','wpthms'),
				'id' => 'customfont_mode',
				'std' => 'disable',
				'type' => 'toggles',
				'options' => $enable_disable
			),
			array( 
				'name' => __('Upload Custom Fonts.','wpthms'),
				'desc' => __('Add your custom font for your site.<br>If you don\'t know how to create a fontface for web, you can generate at: <a href="http://www.fontsquirrel.com/fontface/generator">here</a><br><br>Font You have added:<br>','wpthms'),
				'id' => 'custom_fontface',
				'std' => '',
				'type' => 'repeatable_field',
				'options' => array(
					array(
						'name' => __('Font name','wpthms'),
						'desc' => '',
						'id' => 'font_name',
						'std' => '',
						'type' => 'text'
					),
					array(
						'name' => __('Font weight','wpthms'),
						'desc' => '',
						'id' => 'font_weight',
						'std' => '400',
						'type' => 'select',
						'options' => array(
							'100'=>'100 (Lighter)',
							'200'=>'200',
							'300'=>'300',
							'400'=>__('400 (Normal)','wpthms'),
							'500'=>'500',
							'600'=>'600',
							'700'=>__('700 (Bold)','wpthms'),
							'800'=>'800',
							'900'=>'900'
						)
					),
					array(
						'name' => __('Font style','wpthms'),
						'desc' => '',
						'id' => 'font_style',
						'std' => 'normal',
						'type' => 'select',
						'options' => array(
							'normal'=> __('Normal','wpthms'),
							'italic'=> __('Italic','wpthms')
						)
					),
					array(
						'name' => __('<b>.EOT</b> file','wpthms'),
						'desc' => '',
						'id' => 'font_eot',
						'std' => '',
						'type' => 'media',
						'settings' => array(
							'attr' => 'data-format="mixed"',
							'sanitize' => 'esc_url',
						)
					),
					array(
						'name' => __('<b>.WOFF</b> file','wpthms'),
						'desc' => '',
						'id' => 'font_woff',
						'std' => '',
						'type' => 'media',
						'settings' => array(
							'attr' => 'data-format="mixed"',
							'sanitize' => 'esc_url',
						)
					),
					array(
						'name' => __('<b>.TTF</b> file','wpthms'),
						'desc' => '',
						'id' => 'font_ttf',
						'std' => '',
						'type' => 'media',
						'settings' => array(
							'attr' => 'data-format="mixed"',
							'sanitize' => 'esc_url',
						)
					),
					array(
						'name' => __('<b>.SVG</b> file','wpthms'),
						'desc' => '',
						'id' => 'font_svg',
						'std' => '',
						'type' => 'media',
						'settings' => array(
							'attr' => 'data-format="mixed"',
							'sanitize' => 'esc_url',
						)
					),
				)
			
			),
			
		) ) );
		
		/**
		 * Styling Options
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_stylingoptions', array(	
			array( 
				'name' => __('Styling Options','wpthms'),
				'type' => 'heading',
				'customize' => 1,
				'settings' => array(
					'icon' => 'stylingoptions'
				)
			)
		) ) );
		/**
		 * Styling Options
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_stylingoptions_overall', array(	
			array( 
				'name' => __('Overall','wpthms'),
				'type' => 'subheading',
				'desc' => __('Configure Styling rule for overall elements','wpthms')
			),
			array(
				'name' => '',
				'type' => 'info',
				'std' => __('<h3>Choose the built-in skins!, if you dont like them, you can customize by colorpicking your favorite color schemes :)</h3>','wpthms')
			),
			array(
				'name' => __('Built-in Skins','wpthms'),
				'desc' => __('Select your themes alternative color scheme','wpthms'),
				'id' => 'builtin_skins',
				'std' => '',
				'type' => 'color_blocks',
				'settings' =>  array(
					'width' => '30px', 
					'height' => '30px'
				),
				'options' => yt_get_option_vars( 'skins' ),
				'customize' => 1
				
			),
			array(
				'name' => __('Enable Body background pattern','wpthms'),
				'desc' => __('if you are using  child theme, you can also add more background pattern by copying image to theme folderchild-theme-directory/images/bg/','wpthms'),
				'id' => 'body_bg_pattern_mode',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable background pattern','wpthms'),
				)
			),
			array(
				'name' => __('Body Background Pattern','wpthms'),
				'desc' => __('Select a background pattern. (The above uploaded image will be overwritten by this pattern)','wpthms'),
				'id' => 'body_bg_pattern',
				'type' => 'tiles',
				'options' => $bg_images,
				'settings' => array(
					'fold' => 'body_bg_pattern_mode',
				)
			),
			array(
				'name' => __('Body Background options','wpthms'),
				'desc' => __('default : no-repeat - center top - local - auto','wpthms'),
				'id' => 'body_bg_options',
				'std' => array(
					'repeat' => 'no-repeat',
					'position' => 'center top',
					'attachment' => 'local',
					'size' => 'auto',
					'color' => '',

					'image' => '',
				),
				'type' => 'background_options'
			),
			array(
				'type' => 'separator',
				'name' => __('Element colors','wpthms')
			),
			array(
				'name' => __('Primary color','wpthms'),
				'desc' => __('Pick a Primary color for your site.(this will overwrite built-in skins option)','wpthms'),
				'id' => 'primary_color',
				'std' => '',
				'type' => 'colorpicker',
				'customize' => 1
			),
			array( 
				'name' => __('Secondary color','wpthms'),
				'desc' => __('Pick a Secondary color for your site','wpthms'),
				'id' => 'secondary_color',
				'std' => '',
				'type' => 'colorpicker',
				'customize' => 1
			),
			array(
				'name' => __('Text color','wpthms'),
				'desc' => __('Pick a Text color for your site','wpthms'),
				'id' => 'text_color',
				'std' => '',
				'type' => 'colorpicker',
				'customize' => 1,
			),
			array( 
				'name' => __('Custom CSS','wpthms'),
				'desc' => __('Quickly add some CSS to your theme by adding it to this block.','wpthms'),
				'id' => 'custom_css',
				'std' => '/* Custom CSS*/',
				'type' => 'textarea',
				'class' => 'yt-widefat-section yt-tabifiable-textarea',
				'settings' => array(
					'rows' => '20',
					'sanitize' => false
				),
			)
		) ) );
		/**
		 * Styling Options - Header
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_stylingoptions_header', array(
			array( 
				'name' => __('Header','wpthms'),
				'type' => 'subheading',
				'desc' => __('Configure Styling rule for elements in site Header','wpthms'),
			),
			array(
				'name' => __('Header color style','wpthms'),
				'desc' => '',
				'id' => 'header_color_style',
				'std' => 'dark',
				'type' => 'select',
				'options' => array(
					'dark' => __( 'Dark (default)','wpthms'),
					'light' => __( 'Light','wpthms'),
					'color' => __( 'Primary color','wpthms'),
				),
				'customize' => 1
			),
			array(
				'name' => __('Background pattern','wpthms'),
				'desc' => __('if you are using  child theme, you can also add more background pattern by copying image to theme folderchild-theme-directory/images/bg/','wpthms'),
				'id' => 'header_bg_pattern_mode',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable background pattern','wpthms'),
				)
			),
			array(
				'name' => __('Background image options','wpthms'),
				'desc' => __('default : no-repeat - center top - local - auto','wpthms'),
				'id' => 'header_bg_options',
				'std' => array(
					'repeat' => 'no-repeat',
					'position' => 'center top',
					'attachment' => 'local',
					'size' => 'auto',
					'color' => '',
					'image' => '',
				),
				'type' => 'background_options',
			),
			array(
				'name' => __('Background Pattern','wpthms'),
				'desc' => __('Select a background pattern. (The above uploaded image will be overwritten by this pattern)','wpthms'),
				'id' => 'header_bg_pattern',
				'std' => $bg_images_url.'bg.png',
				'type' => 'tiles',
				'options' => $bg_images,
				'settings' => array(
					'fold' => 'header_bg_pattern_mode',
				)
			)
			
		
		) ) );
		/**
		 * Styling Options - Content
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_stylingoptions_content', array(	
			array( 
				'name' => __('Content','wpthms'),
				'type' => 'subheading',
				'desc' => __('Configure Styling rule for elements in site Content','wpthms'),
			),
			array(
				'type' => 'separator',
				'name' => __('Content Background Options','wpthms')
			),
			array(
				'name' => __('Background pattern','wpthms'),
				'desc' => __('if you are using  child theme, you can also add more background pattern by copying image to theme folderchild-theme-directory/images/bg/','wpthms'),
				'id' => 'content_bg_pattern_mode',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable background pattern','wpthms'),
				)
			),
			array(
				'name' => __('Background Options','wpthms'),
				'desc' => __('default : no-repeat - center top - local - auto','wpthms'),
				'id' => 'content_bg_options',
				'std' => array(
					'repeat' => 'no-repeat',
					'position' => 'center top',
					'attachment' => 'local',
					'size' => 'auto',
					'color' => '',

					'image' => '',
				),
				'type' => 'background_options'
			),
			array(
				'name' => __('Background Pattern','wpthms'),
				'desc' => __('Select a background pattern. (The above uploaded image will be overwritten by this pattern)','wpthms'),
				'id' => 'content_bg_pattern',
				'std' => $bg_images_url.'bg.png',
				'type' => 'tiles',
				'options' => $bg_images,
				'settings' => array(
					'fold' => 'content_bg_pattern_mode',
				)
				
			),
		) ) );
		/**
		 * Styling Options - Footer
		 */
		$yt_options = array_merge( $yt_options, apply_filters( 'yt_theme_options_stylingoptions_footer', array(	
			array( 
				'name' => __('Footer','wpthms'),
				'type' => 'subheading',
				'desc' => __('Configure Styling rule for elements in site Footer','wpthms'),
			),
			array(
				'name' => __('Footer Widgets Background Options','wpthms'),
				'desc' => __('default : no-repeat - center top - local - auto','wpthms'),
				'id' => 'footer_widgets_bg_options',
				'std' => array(
					'repeat' => 'no-repeat',
					'position' => 'center top',
					'attachment' => 'local',
					'size' => 'auto',
					'color' => '',
					
					'image' => '',
				),
				'type' => 'background_options',
			),	
			array(
				'name' => __('Background Pattern','wpthms'),
				'desc' => __('if you are using  child theme, you can also add more background pattern by copying image to theme folderchild-theme-directory/images/bg/','wpthms'),
				'id' => 'footer_widgets_bg_pattern_mode',
				'std' => 0,
				'type' => 'checkbox',
				'class' => 'yt-section-toggle-checkbox',
				'settings' => array(
					'folds' => '0',
					'label' => __('Toggle this to enable background pattern','wpthms'),
				)
			),
			array(
				'name' => __('Background Pattern','wpthms'),
				'desc' => __('Select a background pattern. (The above uploaded image will be overwritten by this pattern)','wpthms'),
				'id' => 'footer_widgets_bg_pattern',
				'std' => $bg_images_url.'bg.png',
				'type' => 'tiles',
				'options' => $bg_images,
				'settings' => array(
					'fold' => 'footer_widgets_bg_pattern_mode',
				)
			),	
			array(
				'name' =>  __('Footer Copyright info. Background Color','wpthms'),
				'desc' => __('Pick a background color for the footer copyright area .','wpthms'),
				'id' => 'footer_extra_bg_color',
				'std' => '',
				'type' => 'colorpicker',
				'customize' => 1,
			),
		) ) );
							
		return $yt_options;
		
	}
}