<?php
// This file is not called from WordPress. We don't like that.
! defined( 'ABSPATH' ) and exit;

/**
 **********************************************************************************************************
 * 												DO NOT EDIT THIS FILE
 **********************************************************************************************************
 * Theme functions
 *
 * @author		wpthms
 * @copyright	Copyright ( c ) wpthms
 * @link		http://wpthms.com
 * @since		Version 1.0
 * @package 	Yeah Includes
 */

/**
 * Enable shortcode in text widget
 */
add_filter('widget_text', 'do_shortcode');

/**
 * YT_Shortcode_Generator class
 */
if( class_exists( 'YT_Shortcode_Generator' ) ){

	//add_filter( 'yt_shortcode_default_settings_fields', '__return_false' );

	add_filter( 'yt_shortcode_front_css_bootstrap', '__return_false' );
	add_filter( 'yt_shortcode_front_js_bootstrap', '__return_false' );
	//add_filter( 'yt_shortcode_editor_style_css_bootstrap', '__return_false' );

	add_filter( 'yt_shortcode_setting_fields', 'yt_theme_shortcode_fields' );
}

if ( ! function_exists( 'do_shortcode' ) ) {
	function do_shortcode( $content ) {
		$content = do_shortcode( shortcode_unautop( $content ) );
		$content = preg_replace( '#^<\/p>|^<br \/>|<p>$#', '', $content );
		return $content;
	} 
}

if( !function_exists( 'yt_theme_shortcode_fields' ) ){

	function yt_theme_shortcode_fields( $fields ){
 		$optionsTrueFalse = array(
 			'true' => __('True', 'wpthms'),
 			'false' => __('False', 'wpthms')
 		);
		
 		$optionOrderBy = array(
 			'date'	=> __('Date', 'wpthms'),
 			'title'	=> __('Title', 'wpthms'),
 			'name'	=> __('Post slug', 'wpthms'),
 			'author'	=> __('Author', 'wpthms'),
 			'comment_count'	=> __('Number of comments', 'wpthms'),
 			'modified'	=> __('Last modified date', 'wpthms'),
 			'rand'	=> __('Random order', 'wpthms'),
 		);

 		if( function_exists('yt_simple_post_views_tracker_display') ){
 			$optionOrderBy['meta_value_num'] = __('Post views', 'wpthms');
 		}

		/**
		 * Post List
		 */
		$fields['post_list'] = apply_filters( 'yt_theme_shortcode_args_post_list', array(
					
			'name' => __('Post List', 'wpthms'),
			'desc' => '',
			'settings' => array(
				'iconfont' => '',
				'iconimage' => '',
				'syntax' => '[post_list title="{{title}}" style="{{style}}" cat="{{cat}}" tags="{{tags}}" count="{{count}}" exclude_format="{{exclude_format}}" order="{{order}}" orderby="{{orderby}}" time_period="{{time_period}}" show_icon="{{show_icon}}" show_cat="{{show_cat}}" show_date="{{show_date}}"]'
			),
			'options' => array(
				'title' => array(
					'std' => '',
					'type' => 'text',
					'name' => __('Title', 'wpthms'),
					'desc' => '',
				),
				'style' => array(
					'std' => '',
					'type' => 'select',
					'options' => array(
						'small' => __('Default (Small)', 'wpthms'),
						'large' => __('Large', 'wpthms'),
						'mixed' => __('First Large', 'wpthms'),
						'number' => __('Number (no thumb)', 'wpthms'),
						'nothumb' => __('Title Only', 'wpthms'),
						'thumb_first' => __('First item has thumbnail', 'wpthms'),
					),
					'name' => __('Thumbnail style:', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'cat' => array(
					'std' => '',
					'type' => 'select',
					'options' => yt_get_category_list(),
					'name' => __('Categories', 'wpthms'),
					'desc' => __('Specify categories to retrieve posts from. Hold cmd/ctrl + click to select/deselect multiple tagsb<br>If no category was selected, retrieve all', 'wpthms'),
					'settings' => array(
						'multiple' => 1
					)
				),
				'tags' => array(
					'std' => '',
					'type' => 'select',
					'options' => yt_get_tag_list(),
					'name' => __('Tagged in (optional):', 'wpthms'),
					'desc' => __('Specify tags to retrieve posts from. Hold cmd/ctrl + click to select/deselect multiple tags', 'wpthms'),
					'settings' => array(
						'multiple' => 1
					)
				),

				'exclude_format' => array(
					'name' 		=> __( 'Exclude post format', 'wpthms' ),
					'desc'		=> __( 'Specify post formats you don\'t want to retrieve.', 'wpthms' ),
					'std' 		=> '',
					'type' 		=> 'select_alt',
					'options' 	=> yt_get_supported_post_formats(),
					'settings' => array(
						'multiple' => 1
					)
				),
				'count' => array(
					'std' => '5',
					'type' => 'number',
					'name' => __('Number of Post', 'wpthms'),
					'desc' => '',
				),
				'order' => array(
					'std' => '',
					'type' => 'select',
					'options' => array(
						'DESC' => __('Descending', 'wpthms'),
						'ASC' => __('Ascending', 'wpthms'),
					),
					'name' => __('Order', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'orderby' => array(
					'std' => '',
					'type' => 'select',
					'options' => $optionOrderBy,
					'name' => __('Order by', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'time_period' => array(
					'std' => '',
					'type' => 'select',
					'options' => array(
						'default' => __('Default', 'wpthms'),
						'this_week' => __('This week', 'wpthms'),
						'last_week' => __('Last week', 'wpthms'),
						'this_month' => __('This Month', 'wpthms'),
						'last_month' => __('Last Month', 'wpthms'),
						'last_30days' => __('Last 30 days', 'wpthms'),
					),
					'name' => __('Time period:', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'show_icon' => array(
					'std' => 'false',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Show views/comment counter', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'show_cat' => array(
					'std' => 'false',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __(' Show category tag', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'show_date' => array(
					'std' => 'true',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Show post date', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'show_rating' => array(
					'std' => 'true',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Show Review result', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
			)
		) );


		/**
		 * Slider
		 */
		$fields['slider'] = apply_filters( 'yt_theme_shortcode_args_slider', array(
					
			'name' => __('Slider', 'wpthms'),
			'desc' => '',
			'settings' => array(
				'iconfont' => '',
				'iconimage' => '',
				'syntax' => '[slider directionnav="{{directionnav}}" controlnav="{{controlnav}}" pauseplay="{{pauseplay}}" animation="{{animation}}" slideshow="{{slideshow}}" slideshowspeed="{{slideshowspeed}}" animationspeed="{{animationspeed}}"]{{content}}[/slider]'
			),
			'options' => array(

				'directionnav' => array(
					'std' => 'false',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Direction Nav', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'controlnav' => array(
					'std' => 'true',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Control Nav', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'pauseplay' => array(
					'std' => 'false',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Pause/Play', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'animation' => array(
					'std' => 'fade',
					'type' => 'select',
					'options' => array(
						'fade' => __('Fade', 'wpthms'),
						'slide'=> __('Slide', 'wpthms')
					),
					'name' => __('Effect', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'slideshow' => array(
					'std' => 'true',
					'type' => 'select',
					'options' => $optionsTrueFalse,
					'name' => __('Autoplay', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'slideshowspeed' => array(
					'std' => 7000,
					'type' => 'number',
					'name' => __('Slideshow Speed', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'animationspeed' => array(
					'std' => 700,
					'type' => 'number',
					'name' => __('Animation Speed', 'wpthms'),
					'desc' => '',
					'settings' => array()
				),
				'content' => array(
					'name' => __('Add list items', 'wpthms'),
					'desc' => __('if only content is entered, simple style will be used', 'wpthms'),
					'std' => '',
					'type' => 'repeatable',
					'settings' => array(
						'iconfont' => '',
						'iconimage' => '',
						'syntax' => '<br>[slide caption="{{caption}}" url="{{url}}"]',
						'add_more' => __('slide', 'wpthms'),
					
					),
					'options' => array(
					
						'caption' => array(
							'std' => 'Slide Caption',
							'type' => 'text',
							'name' => __('Caption (optional)', 'wpthms'),
							'desc' => ''
						),
						'url' => array(
							'std' => '',
							'type' => 'media',
							'name' => __('Image URL', 'wpthms'),
							'desc' => __('Upload image', 'wpthms')
						),
					)
				),
			)
		));

		return $fields;
	}
}



add_shortcode( 'post_list', 'yt_theme_shortcode_post_list' );
/*===========================================================*/
/**
 * Post List
 */
function yt_theme_shortcode_post_list( $atts, $content = null ) {

	extract( shortcode_atts( array(
		'direction'	=> 'vertical',
		'column'	=> 4,
		'title' => '',
		'style' => 'small',
		'cat' => '',
		'tags' => '',
		'count' => 5,
		'exclude_format' => '',
		'order' => 'DESC',
		'orderby' => 'date',
		'time_period' => '',
		'show_icon' => 0,
		'show_cat' => 0,
		'show_date' => 1,
		'show_rating' => 0,
		'scroll_infinitely'	=> 0,
		'excerpt'	=> 0,
	), $atts));

	$cat_ids = !empty( $cat ) && is_string( $cat ) ? explode( ',', $cat ) : array();
	$tags_ids = !empty( $tags ) && is_string( $tags ) ? explode( ',', $tags ) : array();
	$exclude_formats = !empty( $exclude_format ) && is_string( $exclude_format ) ? explode( ',', $exclude_format ) : array();

	$instance = array();

	$instance['style'] 		= !empty( $style ) ? $style : 'small';
	$instance['category'] 	= $cat_ids;
	$instance['tags'] 		= $tags_ids;
	$instance['order'] 		= $order;
	$instance['orderby'] 	= $orderby;
	$instance['number'] 	= intval( $count );
	$instance['time_period'] = $time_period;

	$instance['exclude_format'] = $exclude_formats;
	$instance['show_icon'] 	= $show_icon == 'true' ? 1 : 0;
	$instance['show_cat'] 	= $show_cat == 'true' ? 1 : 0;
	$instance['show_date'] 	= $show_date == 'true' ? 1 : 0;
	$instance['show_rating'] 	= $show_date == 'true' ? 1 : 0;
	$instance['scroll_infinitely'] = $scroll_infinitely == 'true' ? 'on' : 0;
	$instance['column'] 	= intval( $column );
	$instance['direction'] 	= $direction;
	$instance['excerpt'] 	= $excerpt == 'true' ? 1 : 0;

	$output = $title ? '<h3 class="widget-title">' . $title . '</h3>' : '';
	// print_r( $instance ); die();
	if( function_exists( 'yt_site_post_list' ) && is_callable( 'yt_site_post_list' ) ){
		ob_start();
			yt_site_post_list( $instance );	
			
			$output .= ob_get_contents();
		ob_end_clean();
	}


	return apply_filters( 'yt_theme_shortcode_post_list_html', $output, $atts );
}

add_shortcode( 'slider', 'yt_theme_shortcode_slider_wrapper' );
/*===========================================================*/
/**
 * Slider
 */
function yt_theme_shortcode_slider_wrapper( $atts, $content = null ) {

	extract( shortcode_atts( array(
		'directionnav' => 'false',
		'controlnav' => 'true',
		'pauseplay' => 'false',
		'animation' => 'fade',
		'slideshow' => 'true',
		'slideshowspeed' 	=> 7000,
		'animationspeed' 	=> 600,
		'css3effect'		=> ''
	), $atts));

	$slider_settings = apply_filters( 'yt_theme_shortcode_slider_settings', array(
		'directionNav' => 'true' === $directionnav ? true : false,
		'controlNav' => 'true' === $controlnav ? true : false,
		'pausePlay' => 'true' === $pauseplay ? true : false,
		'animation' => 'slide' == $animation ? $animation : 'fade',
		'slideshow' => 'true' === $slideshow ? true : false,
		'slideshowSpeed' 	=> $slideshowspeed,
		'animationSpeed' 	=> $animationspeed ,
		'css3Effect'		=> '',
	), 'slider');

	$output = '<div class="yeahslider" data-settings="' . esc_attr( json_encode( $slider_settings ) ) . '">';
		$output .= '<ul class="slides">';
		$output .= do_shortcode( $content );
		$output .= '</ul>';
	$output .= '</div>';


	return apply_filters( 'yt_theme_shortcode_slider_html', $output, $atts );
}


add_shortcode( 'slide', 'yt_theme_shortcode_slide_item' );
function yt_theme_shortcode_slide_item( $atts, $content = null ) {

	extract( shortcode_atts( array(
		'caption' => '',
		'url' => '',
	), $atts));

	$output = '<li>';
	$output .= '<img src="' . esc_url( $url ) . '">';
	$output .= $caption ? '<div class="thumbnail-caption">' . $caption . '</div>' : '';
	$output .= '</li>';


	return apply_filters( 'yt_theme_shortcode_slider_html', $output, $atts );
}